diff a/test/micro/org/openjdk/bench/valhalla/invoke/InlineField1.java b/test/micro/org/openjdk/bench/valhalla/invoke/InlineField1.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/invoke/InlineField1.java
@@ -0,0 +1,262 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.invoke;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@Warmup(iterations = 5, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class InlineField1 {
+
+    public static final int SIZE = 128;
+
+    public interface MyInterface {
+        public int my_method();
+    }
+
+    public static value class Val1 implements MyInterface {
+        public final int f0;
+        public Val1(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static value class Val2 implements MyInterface {
+        public final int f0;
+        public Val2(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static value class Val3 implements MyInterface {
+        public final int f0;
+        public Val3(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static class Val1Wrapper {
+        public Val1 f;
+
+        public Val1Wrapper(Val1 f) {
+            this.f = f;
+        }
+    }
+
+    public static class Ref1Wrapper {
+        public Val1 f;
+
+        public Ref1Wrapper(Val1 f) {
+            this.f = f;
+        }
+    }
+
+    public static class IntWrapper {
+        public MyInterface f;
+
+        public IntWrapper(MyInterface f) {
+            this.f = f;
+        }
+    }
+
+    @State(Scope.Thread)
+    public static class Val1State {
+        public Val1Wrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new Val1Wrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Val1Wrapper(new Val1(i));
+            }
+        }
+    }
+
+    @State(Scope.Thread)
+    public static class Ref1State {
+        public Ref1Wrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new Ref1Wrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref1Wrapper(new Val1(i));
+            }
+        }
+    }
+
+    @State(Scope.Thread)
+    public static class IntStateBase {
+        public IntWrapper[] arr;
+    }
+
+    public static class Int1State extends IntStateBase {
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Val1(i));
+            }
+        }
+    }
+
+    public static class Int2State extends IntStateBase {
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Val2(i));
+            }
+        }
+    }
+
+    public static class Int3State extends IntStateBase {
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Val3(i));
+            }
+        }
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int reduceVal(Val1Wrapper[] arr) {
+        int r = 0;
+        for (int i = 0; i < arr.length; i++) {
+            r += arr[i].f.my_method();
+        }
+        return r;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int reduceRef(Ref1Wrapper[] arr) {
+        int r = 0;
+        for (int i = 0; i < arr.length; i++) {
+            r += arr[i].f.my_method();
+        }
+        return r;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int reduceInt(IntWrapper[] arr) {
+        int r = 0;
+        for (int i = 0; i < arr.length; i++) {
+            r += arr[i].f.my_method();
+        }
+        return r;
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Val(Val1State st0, Val1State st1, Val1State st2, Val1State st3, Val1State st4, Val1State st5) {
+        return reduceVal(st0.arr) +
+                reduceVal(st1.arr) +
+                reduceVal(st2.arr) +
+                reduceVal(st3.arr) +
+                reduceVal(st4.arr) +
+                reduceVal(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Ref(Ref1State st0, Ref1State st1, Ref1State st2, Ref1State st3, Ref1State st4, Ref1State st5) {
+        return reduceRef(st0.arr) +
+                reduceRef(st1.arr) +
+                reduceRef(st2.arr) +
+                reduceRef(st3.arr) +
+                reduceRef(st4.arr) +
+                reduceRef(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Int(Int1State st0, Int1State st1, Int1State st2, Int1State st3, Int1State st4, Int1State st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target2_Int(Int1State st0, Int2State st1, Int1State st2, Int2State st3, Int1State st4, Int2State st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target3_Int(Int1State st0, Int2State st1, Int3State st2, Int1State st3, Int2State st4, Int3State st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/invoke/InlineRec.java b/test/micro/org/openjdk/bench/valhalla/invoke/InlineRec.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/invoke/InlineRec.java
@@ -0,0 +1,99 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.invoke;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Param;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@Warmup(iterations = 5, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class InlineRec {
+
+    @Param("100")
+    public int depth;
+
+    public static value class V {
+        final int v;
+
+        public V(int v) {
+            this.v = v;
+        }
+
+        public V addL(V y) {
+            return this.v == 0 ? y : new V(this.v - 1).addL(new V(y.v + 1));
+        }
+
+        public V addR(V y) {
+            return y.v == 0 ? this : new V(this.v + 1).addR(new V(y.v - 1));
+        }
+    }
+
+    public static V s_addL(V x, V y) {
+        return x.v == 0 ? y : s_addL(new V(x.v - 1), new V(y.v + 1));
+    }
+
+    public static V s_addR(V x, V y) {
+        return y.v == 0 ? x : s_addR(new V(x.v + 1), new V(y.v - 1));
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int statL() {
+        return s_addL(new V(depth), new V(depth)).v;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int statR() {
+        return s_addR(new V(depth), new V(depth)).v;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int instL() {
+        return new V(depth).addL(new V(depth)).v;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int instR() {
+        return new V(depth).addR(new V(depth)).v;
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/matrix/Base.java b/test/micro/org/openjdk/bench/valhalla/matrix/Base.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/matrix/Base.java
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2016, 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.matrix;
+
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Param;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@OutputTimeUnit(TimeUnit.MICROSECONDS)
+@Warmup(iterations = 3, time = 3)
+@Measurement(iterations = 3, time = 8)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class Base {
+
+
+    @Param({
+            "20",
+            "100",
+            "360",
+    })
+    public int size;
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/matrix/Identity.java b/test/micro/org/openjdk/bench/valhalla/matrix/Identity.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/matrix/Identity.java
@@ -0,0 +1,107 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.matrix;
+
+import org.openjdk.bench.valhalla.types.Complex;
+import org.openjdk.bench.valhalla.types.RComplex;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+import java.util.concurrent.ThreadLocalRandom;
+
+public abstract class Identity extends Base {
+
+    public static final Complex IZERO = new RComplex(0,0);
+    public static final RComplex RZERO = new RComplex(0,0);
+
+    private static void populate(Complex[][] m) {
+        int size = m.length;
+        for (int i = 0; i < size; i++) {
+            for (int j = 0; j < size; j++) {
+                m[i][j] = new RComplex(ThreadLocalRandom.current().nextDouble(), ThreadLocalRandom.current().nextDouble());
+            }
+        }
+    }
+
+    public static class Ref extends Identity {
+        RComplex[][] A;
+        RComplex[][] B;
+
+        @Setup
+        public void setup() {
+            A = new RComplex[size][size];
+            populate(A);
+            B = new RComplex[size][size];
+            populate(B);
+        }
+
+        @Benchmark
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public RComplex[][] multiply() {
+            int size = A.length;
+            RComplex[][] R = new RComplex[size][size];
+            for (int i = 0; i < size; i++) {
+                for (int j = 0; j < size; j++) {
+                    RComplex s = RZERO;
+                    for (int k = 0; k < size; k++) {
+                        s = s.add(A[i][k].mul(B[k][j]));
+                    }
+                    R[i][j] = s;
+                }
+            }
+            return R;
+        }
+    }
+
+    public static class Int extends Identity {
+        Complex[][] A;
+        Complex[][] B;
+
+        @Setup
+        public void setup() {
+            A = new Complex[size][size];
+            populate(A);
+            B = new Complex[size][size];
+            populate(B);
+        }
+
+        @Benchmark
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public Complex[][] multiply() {
+            int size = A.length;
+            Complex[][] R = new Complex[size][size];
+            for (int i = 0; i < size; i++) {
+                for (int j = 0; j < size; j++) {
+                    Complex s = IZERO;
+                    for (int k = 0; k < size; k++) {
+                        s = s.add(A[i][k].mul(B[k][j]));
+                    }
+                    R[i][j] = s;
+                }
+            }
+            return R;
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/matrix/Inline.java b/test/micro/org/openjdk/bench/valhalla/matrix/Inline.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/matrix/Inline.java
@@ -0,0 +1,266 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.matrix;
+
+import org.openjdk.bench.valhalla.types.Complex;
+import org.openjdk.bench.valhalla.types.QComplex;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+import java.util.concurrent.ThreadLocalRandom;
+
+public abstract class Inline extends Base {
+
+    public static final Complex IZERO = new QComplex(0,0);
+    public static final QComplex VZERO = new QComplex(0,0);
+    public static final QComplex RZERO = new QComplex(0,0);
+
+    private static void populate(Complex[][] m) {
+        int size = m.length;
+        for (int i = 0; i < size; i++) {
+            for (int j = 0; j < size; j++) {
+                m[i][j] = new QComplex(ThreadLocalRandom.current().nextDouble(), ThreadLocalRandom.current().nextDouble());
+            }
+        }
+    }
+
+//    public static class Ref extends Inline {
+//
+//    }
+
+    public static class Ref extends Inline {
+        QComplex[][] A;
+        QComplex[][] B;
+
+        @Setup
+        public void setup() {
+            A = new QComplex[size][size];
+            populate(A);
+            B = new QComplex[size][size];
+            populate(B);
+        }
+
+        @Benchmark
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public QComplex[][] multiply() {
+            int size = A.length;
+            QComplex[][] R = new QComplex[size][size];
+            for (int i = 0; i < size; i++) {
+                for (int j = 0; j < size; j++) {
+                    QComplex s = RZERO;
+                    for (int k = 0; k < size; k++) {
+                        s = s.add(A[i][k].mul(B[k][j]));
+                    }
+                    R[i][j] = s;
+                }
+            }
+            return R;
+        }
+
+//        @Benchmark
+//        public QComplex[][] multiplyCacheFriendly() {
+//            int size = A.length;
+//            QComplex[][] R = new QComplex[size][size];
+//            for (int i = 0; i < size; i++) {
+//                for (int k = 0; k < size; k++) {
+//                    QComplex aik = A[i][k];
+//                    for (int j = 0; j < size; j++) {
+//                        R[i][j] = R[i][j].add(aik.mul(B[k][j]));
+//                    }
+//                }
+//            }
+//            return R;
+//        }
+
+    }
+
+    public static class Val extends Inline {
+        QComplex[][] A;
+        QComplex[][] B;
+
+        @Setup
+        public void setup() {
+            A = new QComplex[size][size];
+            populate(A);
+            B = new QComplex[size][size];
+            populate(B);
+        }
+
+        @Benchmark
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public QComplex[][] multiply() {
+            int size = A.length;
+            QComplex[][] R = new QComplex[size][size];
+            for (int i = 0; i < size; i++) {
+                for (int j = 0; j < size; j++) {
+                    QComplex s = VZERO;
+                    for (int k = 0; k < size; k++) {
+                        s = s.add(A[i][k].mul(B[k][j]));
+                    }
+                    R[i][j] = s;
+                }
+            }
+            return R;
+        }
+
+//        @Benchmark
+//        public QComplex[][] multiplyCacheFriendly() {
+//            int size = A.length;
+//            QComplex[][] R = new QComplex[size][size];
+//            for (int i = 0; i < size; i++) {
+//                for (int k = 0; k < size; k++) {
+//                    QComplex aik = A[i][k];
+//                    for (int j = 0; j < size; j++) {
+//                        R[i][j] = R[i][j].add(aik.mul(B[k][j]));
+//                    }
+//                }
+//            }
+//            return R;
+//        }
+
+    }
+
+    public static class Int extends Inline {
+        Complex[][] A;
+        Complex[][] B;
+
+        @Setup
+        public void setup() {
+            A = new Complex[size][size];
+            populate(A);
+            B = new Complex[size][size];
+            populate(B);
+        }
+
+        @Benchmark
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public Complex[][] multiply() {
+            int size = A.length;
+            Complex[][] R = new Complex[size][size];
+            for (int i = 0; i < size; i++) {
+                for (int j = 0; j < size; j++) {
+                    Complex s = IZERO;
+                    for (int k = 0; k < size; k++) {
+                        s = s.add(A[i][k].mul(B[k][j]));
+                    }
+                    R[i][j] = s;
+                }
+            }
+            return R;
+        }
+    }
+
+    public static class ICov extends Inline {
+        Complex[][] A;
+        Complex[][] B;
+
+        @Setup
+        public void setup() {
+            A = new QComplex[size][size];
+            populate(A);
+            B = new QComplex[size][size];
+            populate(B);
+        }
+
+        @Benchmark
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public Complex[][] multiply() {
+            int size = A.length;
+            Complex[][] R = new QComplex[size][size];
+            for (int i = 0; i < size; i++) {
+                for (int j = 0; j < size; j++) {
+                    Complex s = IZERO;
+                    for (int k = 0; k < size; k++) {
+                        s = s.add(A[i][k].mul(B[k][j]));
+                    }
+                    R[i][j] = s;
+                }
+            }
+            return R;
+        }
+
+//        @Benchmark
+//        public Complex[][] multiplyCacheFriendly() {
+//            int size = A.length;
+//            Complex[][] R = new QComplex[size][size];
+//            for (int i = 0; i < size; i++) {
+//                for (int k = 0; k < size; k++) {
+//                    Complex aik = A[i][k];
+//                    for (int j = 0; j < size; j++) {
+//                        R[i][j] = R[i][j].add(aik.mul(B[k][j]));
+//                    }
+//                }
+//            }
+//            return R;
+//        }
+
+    }
+
+    public static class RCov extends Inline {
+        QComplex[][] A;
+        QComplex[][] B;
+
+        @Setup
+        public void setup() {
+            A = new QComplex[size][size];
+            populate(A);
+            B = new QComplex[size][size];
+            populate(B);
+        }
+
+        @Benchmark
+        @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+        public QComplex[][] multiply() {
+            int size = A.length;
+            QComplex[][] R = new QComplex[size][size];
+            for (int i = 0; i < size; i++) {
+                for (int j = 0; j < size; j++) {
+                    QComplex s = RZERO;
+                    for (int k = 0; k < size; k++) {
+                        s = s.add(A[i][k].mul(B[k][j]));
+                    }
+                    R[i][j] = s;
+                }
+            }
+            return R;
+        }
+
+//        @Benchmark
+//        public Complex[][] multiplyCacheFriendly() {
+//            int size = A.length;
+//            Complex[][] R = new QComplex[size][size];
+//            for (int i = 0; i < size; i++) {
+//                for (int k = 0; k < size; k++) {
+//                    Complex aik = A[i][k];
+//                    for (int j = 0; j < size; j++) {
+//                        R[i][j] = R[i][j].add(aik.mul(B[k][j]));
+//                    }
+//                }
+//            }
+//            return R;
+//        }
+
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/matrix/Primitive.java b/test/micro/org/openjdk/bench/valhalla/matrix/Primitive.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/matrix/Primitive.java
@@ -0,0 +1,97 @@
+/*
+ * Copyright (c) 2016, 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.matrix;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+import java.util.concurrent.ThreadLocalRandom;
+
+public class Primitive extends Base {
+
+    double[][] A;
+    double[][] B;
+
+    @Setup
+    public void setup() {
+        A = populate(new double[size][size*2]);
+        B = populate(new double[size][size*2]);
+    }
+
+    private double[][] populate(double[][] m) {
+        int size = m.length;
+        for (int i = 0; i < size; i++) {
+            for (int j = 0; j < size; j++) {
+                m[i][j*2+0] = ThreadLocalRandom.current().nextDouble();
+                m[i][j*2+1] = ThreadLocalRandom.current().nextDouble();
+            }
+        }
+        return m;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public double[][] multiply() {
+        int size = A.length;
+        double[][] R = new double[size][size * 2];
+        for (int i = 0; i < size; i++) {
+            for (int j = 0; j < size; j++) {
+                double s_re = 0;
+                double s_im = 0;
+                for (int k = 0; k < size; k++) {
+                    double are = A[i][k * 2 + 0];
+                    double aim = A[i][k * 2 + 1];
+                    double bre = B[k][j * 2 + 0];
+                    double bim = B[k][j * 2 + 1];
+                    s_re += are * bre - aim * bim;
+                    s_im += are * bim + bre * aim;
+                }
+                R[i][j * 2 + 0] = s_re;
+                R[i][j * 2 + 1] = s_im;
+            }
+        }
+        return R;
+    }
+
+//    @Benchmark
+//    public double[][] multiplyCacheFriendly() {
+//        int size = A.length;
+//        double[][] R = new double[size][size * 2];
+//        for (int i = 0; i < size; i++) {
+//            for (int k = 0; k < size; k++) {
+//                double are = A[i][k * 2 + 0];
+//                double aim = A[i][k * 2 + 1];
+//                for (int j = 0; j < size; j++) {
+//                    double bre = B[k][j * 2 + 0];
+//                    double bim = B[k][j * 2 + 1];
+//                    R[i][j * 2 + 0] += are * bre - aim * bim;
+//                    R[i][j * 2 + 1] += are * bim + bre * aim;
+//                }
+//            }
+//        }
+//        return R;
+//    }
+
+
+}
